#ifndef VC_H
#define VC_H

#include <sys/types.h>

#include "emu_defs.h"
#include "base/termio.h"

extern void set_vc_screen_page(int);

extern void clear_screen(int, int);

extern void restore_vt(int);
extern void disallocate_vt(void);

extern void set_process_control(void);
extern void clear_process_control(void);

extern int  detach(void);
extern void activate(int);

extern void child_close_mouse(void);
extern void child_open_mouse(void);

EXTERN struct screen_stat scr_state;

#endif 

