/*
 * DANG_BEGIN_MODULE
 *
 * Description: Floppy drive chip emulation -- doesn't exist yet
 * 
 * Maintainers: 
 *
 * DANG_END_MODULE
 *
 * $Date: $
 * $Source: $
 * $Revision: $
 * $State: $
 *
 * $Log: $
 */

#include "dosemu.h"
#include "base/iodev.h"
#include "base/int.h"
#include "base/port.h"

static Bit8u floppy_io_read(Bit32u port)
{
  return 0;
}

static void floppy_io_write(Bit32u port, Bit8u value)
{
}

void floppy_init(void)
{
  emu_iodev_t  io_device;

  /* FLOPPY DRIVE */
  io_device.read_portb   = floppy_io_read;
  io_device.write_portb  = floppy_io_write;
  io_device.read_portw   = NULL;
  io_device.write_portw  = NULL;
  io_device.handler_name = "Floppy Drive";
  io_device.start_addr   = 0x03F0;
  io_device.end_addr     = 0x03F7;
  io_device.irq          = 6;
  port_register_handler(io_device);
}

void floppy_reset(void)
{
}

